VERSION 5.00
Begin VB.UserControl FlightSimKtsDial 
   AutoRedraw      =   -1  'True
   ClientHeight    =   3030
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3015
   Picture         =   "FlightSimKtsDial.ctx":0000
   ScaleHeight     =   202
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   201
   ToolboxBitmap   =   "FlightSimKtsDial.ctx":1D502
   Begin VB.Line Line1 
      BorderColor     =   &H00FFFFFF&
      BorderWidth     =   4
      X1              =   101
      X2              =   158
      Y1              =   101
      Y2              =   56
   End
End
Attribute VB_Name = "FlightSimKtsDial"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' *****************************************************************************
'
' Copyright. 2007. Symvionics, Inc. All rights reserved.
'
' Symvionics Inc. ("Symvionics") grants a non-exclusive license for you to use
' and redistribute this software, in both source code and binary forms, and the
' accompanying documentation, if any, free of charge, provided that this
' paragraph, and the following two paragraphs appear in all copies and in all
' derivative works.  In no event shall this source code or this license thereto
' impact upon or fall within the scope of any other agreement that you have with
' Symvionics.
'
' BY USING THIS SOFTWARE, YOU FURTHER AGREE THAT, IN NO EVENT, SHALL SYMVIONICS
' BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR
' CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS
' SOFTWARE, THE ACCOMPANYING DOCUMENTATION, IF ANY, OR ANY DERIVATIVE WORKS.
' YOU AGREE TO DEFEND, INDEMNIFY, AND HOLD HARMLESS SYMVIONICS FROM AND AGAINST
' ALL FINES, PENALTIES, LIABILITIES, DAMAGES, COSTS, AND EXPENSES INCURRED
' BY SYMVIONICS AS A RESULT OF YOUR USE OF THIS SOFTWARE INCLUDING THIRD PARTY
' USE OF ANY DERIVATIVE WORKS CREATED BY YOU.
'
' SYMVIONICS SPECIFICALLY DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING, BUT NOT
' LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
' PARTICULAR PURPOSE.  THE SOFTWARE AND ACCOMPANYING DOCUMENTATION LICENSED
' HEREUNDER ARE PROVIDED "AS IS" WITHOUT WARRANTY OR OBLIGATION OF SUPPORT OR
' MAINTENANCE.
'
' *****************************************************************************

Dim CenterX As Long
Dim CenterY As Long
Dim CurrentValue As Double
Dim RadToDeg As Double
Dim ZeroDegreeOffset As Double
Dim ValueToDegreeRatio As Double
Dim Rads As Double, CosA As Double, SinA As Double
Dim NeedleLength As Long

Private Sub UserControl_Initialize()
    CurrentValue = 50#
    RadToDeg = 0.01745
    ZeroDegreeOffset = 60#
    NeedleLength = 80
    ValueToDegreeRatio = 180# / 415.5
    CenterX = 100
    CenterY = 100
    Line1.X1 = CenterX
    Line1.Y1 = CenterY
    UserControl_SetDialValue CurrentValue
End Sub

Public Property Get Value() As Double
    Value = CurrentValue
End Property

Public Property Let Value(ByVal newVal As Double)
    CurrentValue = newVal
    UserControl_SetDialValue CurrentValue
    PropertyChanged "Value"
End Property

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    CurrentValue = PropBag.ReadProperty("Value", 0#)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "Value", CurrentValue, 0#
End Sub

Private Sub UserControl_SetDialValue(Value As Double)
    ' Rotate Away
    Angle = (Value * ValueToDegreeRatio) - ZeroDegreeOffset
    Rads = RadToDeg * Angle
    Line1.X2 = Cos(Rads) * NeedleLength + CenterX
    Line1.Y2 = Sin(Rads) * NeedleLength + CenterY
    
    'Image1.ToolTipText = Value
End Sub
